/**
 * lights.h
 *
 * Copyright (C) 2000 Jeffrey Fulmer <jdfulmer@armstrong.com>
 * This file is part of wackyd
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
#ifndef LIGHTS_H
#define LIGHTS_H


enum light_state_change
{
  WACKYD_LED_TURN_ON, 
  WACKYD_LED_TURN_OFF, 
  WACKYD_LED_REMAIN
};

typedef struct 
{
  enum light_state_change num;
  enum light_state_change cap;
  enum light_state_change scr;
  long sleep;
} wackyd_led_change_t;

void init_console( int *console, long int *state );
long int get_lights( int console ); 
int set_lights(int console,  wackyd_led_change_t state);
int restore_lights( int console, long int state );
void render_pattern(int console, wackyd_led_change_t pattern[], int elements);

#endif /* LIGHTS_H */
