#include <setup.h>
#include <syslog.h>
#include <sock.h>
#include <list.h>
#include <pattern.h>
#include <protocol.h>
#include <joedog/joedog.h>

void *
default_handler()
{
  int type, state;
 
  blink( my.console, 300000 );
 
  return( NULL );
} 

void *
protocol_handler( int sock )
{
  CONN *C;
  HEAD *H;
  int  count = 0;
  char **lights;
  int type, state;

  C = (CONN*)xmalloc( sizeof( CONN ));
  C->sock = sock;

  H = (HEAD*)malloc( sizeof(HEAD));
  memset( H, 0, sizeof( HEAD ));
 
  if( WACKYsocket_check( C ) < 0 ){
    joe_error( "socket closed due to inactivity" );
    WACKYclose( C );
    blink( my.console, 300000 );
    return;
  }
 
  while( TRUE ){
    char buf[MAXSIZE];
    memset( &buf, 0, sizeof( buf ));
    WACKYreadline( C, buf, sizeof( buf ));
    trim( buf );
    joe_error("=>%s<=", buf );
    if( buf[0]=='\n' || buf[1]=='\n' ) break;
    if( !strncasecmp( buf, "wacky/1.0", 9 )){
      strncpy( H->protocol, buf, 9 );
      strncpy( H->payload,  buf+9, sizeof( buf ));
    }
    else if( buf[0]=='x' || buf[0]=='o' ){
      strncpy( H->protocol, "WACKY/1.0", 9 );
      strncpy( H->payload,  buf, sizeof( buf ));
    }
    if( !strncasecmp( buf, "message: ", 9 )){
      strncpy( H->message, buf, sizeof( H->message ));
    }
  }
  trim( H->payload );
  joe_error("=>%s<=", H->payload );
  trim( H->message );
  joe_error("=>%s<=", H->message );
  if( strlen( H->message ) > 1 ){ joe_error( "%s", H->message ); }
  lights = split( ',', H->payload, &count );

  WACKYclose( C );
  custom_blink( my.console, lights, count );
  free( H );
  free( C );
  return( NULL );
}


