#ifndef SETUP_H
#define SETUP_H

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif /* HAVE_CONFIG_H */

#include <stdio.h>
#include <string.h>
#include <unistd.h>

#ifdef HAVE_SYS_TYPES_H
# include <sys/types.h>
#endif /* HAVE_SYS_TYPES_H */

#ifdef HAVE_SIGNAL_H
# include <signal.h>
#endif /* HAVE_SIGNAL_H */

#ifdef HAVE_FCNTL_H
# include <fcntl.h>
#endif /* HAVE_FCNTL_H */

#include <joedog/joedog.h>
#include <joedog/joepath.h>

#include <list.h>
#include <util.h>

#define  TRUE           1
#define  FALSE          0
#define  MAXSIZE        1024
#define  MSG_NOERROR    010000

#if STDC_HEADERS
# define TOLOWER(Ch) tolower (Ch)
# define TOUPPER(Ch) toupper (Ch)
#else
# define TOLOWER(Ch) (ISUPPER (Ch) ? tolower (Ch) : (Ch))
# define TOUPPER(Ch) (ISLOWER (Ch) ? toupper (Ch) : (Ch))
#endif

#define  ISSEPARATOR(x) ('='==(x))
#define  ISCOMMENT(x)   ('#'==(x))
#define  ISASCII(x)     isascii ((unsigned char)(x))
#define  ISALPHA(x)     isalpha ((unsigned char)(x))
#define  ISSPACE(x)     isspace ((unsigned char)(x))
#define  ISDIGIT(x)     isdigit ((unsigned char)(x))
#define  ISX(x)         ('x'==TOLOWER(x))
#define  ISO(x)         ('o'==TOLOWER(x))  

#ifndef HAVE_SNPRINTF
# define portable_snprintf  snprintf
# define portable_vsnprintf vsnprintf
#endif
 
#ifndef  EXIT_SUCCESS
# define EXIT_SUCCESS   0
#endif /*EXIT_SUCESS*/
#ifndef  EXIT_FAILURE
# define EXIT_FAILURE   1
#endif /*EXIT_FAILURE*/ 

#define  TRUE  1
#define  FALSE 0

/**
 * struct configuration
 */
struct CONFIG
{ 
  int  debug;        /* boolean, turn on debugging info */
  int  classic;      /* boolean, run wackyd in classic  */ 
  int  sock;         /* listener socket, port 9193      */
  char *hostname;    /* wacky server host address       */
  char *portname;    /* wacky server port (default 9193)*/
  int  config;       /* boolean, display configuration  */
  int  console;      /* /dev/console file descriptor    */
  long int state;    /* led bitset                      */
  int  timeout;      /* socket timeout value on select  */
  int  speed;        /* blinking light speed            */ 
  int  done;         /* boolean done blinking, return   */
};

typedef struct 
{
  int console;
  int speel;
} ORDER;

#if INTERN
# define EXTERN /* */
#else
# define EXTERN extern
#endif

EXTERN struct LIST   *list; 
EXTERN struct CONFIG my;
EXTERN char *version_string; 

#endif /* SETUP_H */


